# File: BlueDCSTool.py
# 
# Copyright (c) 2005 by BlueDynamics
# Generator: ArchGenXML Version 1.4.0-beta2 devel 
#            http://plone.org/products/archgenxml
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''unknown <unknown>'''
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *

from IBlueDCSServer import IBlueDCSServer


from Products.BlueDCSTool.config import *

from Products.CMFCore.utils import UniqueObject

    
##code-section module-header #fill in your manual code here
import xmlrpclib
##/code-section module-header

schema=Schema((
    StringField('serverUrl',
        default="http://localhost:8888",
        widget=StringWidget(
            label="DCS Server URL",
            desctiption="Please enter the value of the BlueDCS xmlrpc server",
            label_msgid='BlueDCSTool_label_serverUrl',
            description_msgid='BlueDCSTool_help_serverUrl',
            i18n_domain='BlueDCSTool',
        )
    ),

),
)


##code-section after-schema #fill in your manual code here
##/code-section after-schema

class BlueDCSTool(UniqueObject,BaseContent):
    security = ClassSecurityInfo()
    __implements__ = (getattr(UniqueObject,'__implements__',()),) + (getattr(BaseContent,'__implements__',()),) + (IBlueDCSServer,)


    # This name appears in the 'add' box
    archetype_name             = 'BlueDCSTool'

    meta_type                  = 'BlueDCSTool'
    portal_type                = 'BlueDCSTool'
    allowed_content_types      = []
    filter_content_types       = 0
    global_allow               = 0
    allow_discussion           = 0
    #content_icon               = 'BlueDCSTool.gif'
    immediate_view             = 'base_view'
    default_view               = 'base_view'
    suppl_views                = ()
    typeDescription            = "BlueDCSTool"
    typeDescMsgId              = 'description_edit_bluedcstool'

    actions =  (


       {'action':      "string:$object_url/bluedcs_diagnostics",
        'category':    "object",
        'id':          'diagnostics',
        'name':        'diagnostics',
        'permissions': ("View",),
        'condition'  : 'python:1'
       },


    )
    #toolicon                   = 'BlueDCSTool.gif'

    schema = BaseSchema + \
             schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    # tool-constructors have no id argument, the id is fixed
    def __init__(self, id=None):
        BaseContent.__init__(self,'portal_bluedcs')
        
        ##code-section constructor-footer #fill in your manual code here
        ##/code-section constructor-footer



    #Methods

    security.declarePrivate('getServer')
    def getServer(self):
        return xmlrpclib.Server(self.getServerUrl())


    #methods from Interface IBlueDCSServer

    security.declarePublic('zipconvert')
    def zipconvert(self,inputblob,exportfilter):
        '''
        
        '''
        
        return self.getServer().zipconvert(inputblob,exportfilter)



    security.declarePublic('convert')
    def convert(self,inputblob,exportfilter,inputname='inputfile',outputname='index.html'):
        '''
        
        '''
        i64=inputblob.encode('base64')
        res=self.getServer().convert(i64,exportfilter,inputname,outputname)
        
        return res.decode('base64')



    security.declarePublic('getImportFilters')
    def getImportFilters(self):
        '''
        
        '''
        
        return self.getServer().getImportFilters()



    security.declarePublic('getExportFilters')
    def getExportFilters(self):
        '''
        
        '''
        
        return self.getServer().getExportFilters()



registerType(BlueDCSTool,PROJECTNAME)
# end of class BlueDCSTool

##code-section module-footer #fill in your manual code here
##/code-section module-footer



