from Products.MimetypesRegistry import MimeTypeItem
from StringIO import StringIO
from Products.CMFCore.utils import getToolByName

# Stylesheets
STYLESHEETS = (
    {'id'       : 'bluedcs.css',
     'media'    : 'screen',
     'rendering': 'import'
     },
    )

def registerResources(self, out, toolname, resources):
    tool = getToolByName(self, toolname)
    existing = tool.getResourceIds()
    cook = False
    for resource in resources:
        if not resource['id'] in existing:
            # register additional resource in the specified registry...
            if toolname == "portal_css":
                tool.registerStylesheet(**resource)
            if toolname == "portal_javascripts":
                tool.registerScript(**resource)
            print >> out, "Added %s to %s." % (resource['id'], tool)
        else:
            # ...or update existing one
            parameters = tool.getResource(resource['id'])._data
            for key in [k for k in resource.keys() if k != 'id']:
                originalkey = 'original_'+key
                original = parameters.get(originalkey)
                if not original:
                    parameters[originalkey] = parameters[key]
                parameters[key] = resource[key]
                print >> out, "Updated %s in %s." % (resource['id'], tool)
                cook = True
    if cook:
        tool.cookResources()
    print >> out, "Successfuly Installed/Updated resources in %s." % tool

def install(self):
    out=StringIO()
    print >>out, "Adding new mimetype"
    mimetypes_tool = getToolByName(self, 'mimetypes_registry')
    newtype = MimeTypeItem.MimeTypeItem('HTML post transform',
        ('text/x-new-improved-html',), ('html-transformed',), 0)
    mimetypes_tool.register(newtype)

    print >>out,"Add transform"
    transform_tool = getToolByName(self, 'portal_transforms')
    try:
        # Remove existing transform, if any
        if hasattr(transform_tool.aq_base,'BlueDCSDocTransform'):
            transform_tool._unmapTransform(transform_tool.BlueDCSDocTransform)
        transform_tool.manage_delObjects(['BlueDCSDocTransform'])
    except:
        pass

    try:
        # Remove existing transform, if any
        if hasattr(transform_tool.aq_base,'word_to_html'):
            transform_tool._unmapTransform(transform_tool.word_to_html)
        transform_tool.manage_delObjects(['word_to_html'])
    except:
        pass

    transform_tool.manage_addTransform('BlueDCSDocTransform', 'Products.BlueDCSTool.Transforms')

    # Now we add the styles
    registerResources(self, out, 'portal_css', STYLESHEETS)

    return out.getvalue()
